%% Ghmap test manifolds and homoclinic continuation
    clear all
    global opt
    opt=contset;
    x0=[-1.621146385;-1.621146385];
    p0=[-0.4,1.03,-0.1,0];
    optM=init_FPm_1DMan(@Ghmap,x0,p0,1);
    % Umanifold
    optM.function='Umanifold';  
    optM.distanceInit = 1e-5;
    optM.distanceInit=-optM.distanceInit;
    optM.eps=1e-10;
    optM.nmax=20000;
    optM.deltaMax=0.011;
    optM.deltak=1e-5;
    optM.deltaAlphaMax=0.001;
    optM.deltaAlphaLowMax=0.0001;

    [a,l]=growman(optM);
    % Smanifold
    optM.function='Smanifold';
    % n.b. some parameters are used only here, ex: NtwMax
    [b,l]=growman(optM);
    % plot
    figure
    ylim([-2,1]);
    xlim([-2,1]);
    line(x0(1),x0(2),'marker','.','color','k')
    line(a(1,:),a(2,:),'color','r')
    line(b(1,:),b(2,:),'color','k')
    % homocline curves
    % hom=findintersections(a,b,1);
    hom=Projectie2(a,b,1);
    % plot some homoclinic curves
    % the primaries (the 2 longest curves)
    c=hom{4};
    d=hom{end};
    line(c(1,:),c(2,:),'color','g','marker','.')
    line(d(1,:),d(2,:),'color','m','marker','.')
    % some secondaries
    %e=hom{12};
    %f=hom{13};
    %g=hom{14};
    %h=hom{15};
    %line(e(1,:),e(2,:),'color','g','marker','.')
    %line(f(1,:),f(2,:),'color','m','marker','.')
    %line(g(1,:),g(2,:),'color','c','marker','.')
    %line(h(1,:),h(2,:),'color','y','marker','.')
    %% continuation of the primary curve
    opt=contset;
    opt=contset(opt,'MaxNumPoints',100);
    opt=contset(opt,'Singularities',1);
    opt=contset(opt,'MinStepsize',1e-8);
    [x0hom,v0hom]=init_Hom_Hom(@Ghmap,[x0,c],p0,2,1);
    [xhomc1,vhomc1,shomc1,hhomc1,fhomc1]=cont(@homoclinic,x0hom,[],opt);
    opt=contset(opt,'Backward',1);
    [xhomc2,vhomc2,shomc2,hhomc2,fhomc2]=cont(@homoclinic,x0hom,[],opt);
    figure
    cpl(xhomc1,vhomc1,shomc1,[size(xhomc1,1),14])
    cpl(xhomc2,vhomc2,shomc2,[size(xhomc2,1),14])
    figure
    cpl(xhomc1,vhomc1,shomc1,[size(xhomc1,1),1])
    cpl(xhomc2,vhomc2,shomc2,[size(xhomc2,1),1])
    
