function out = LeslieGower
out{1} = @init;
out{2} = @fun_eval;
out{3} = @jacobian;
out{4} = @jacobianp;
out{5} = @hessians;
out{6} = @hessiansp;
out{7} = @der3;
out{8} = @der4;
out{9} = @der5;
out{10} = @userf1;

% --------------------------------------------------------------------------
function dydt = fun_eval(t,kmrgd,b1,b2,ma,mj,my,mz,cjj,cja,cyy,cyz,cjy,cjz,cyj,cya)
dydt=[(b1*kmrgd(2))/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4)),;
(1-mj)*kmrgd(1)+(1-ma)*kmrgd(2),;
(b2*kmrgd(4))/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4)),;
(1-my)*kmrgd(3)+(1-mz)*kmrgd(4),;];

% --------------------------------------------------------------------------
function [tspan,y0,options] = init
handles = feval(LeslieGower);
y0=[0,0,0,0];
options = odeset('Jacobian',handles(3),'JacobianP',handles(4),'Hessians',handles(5),'HessiansP',handles(6));
tspan = [0 10];

% --------------------------------------------------------------------------
function jac = jacobian(t,kmrgd,b1,b2,ma,mj,my,mz,cjj,cja,cyy,cyz,cjy,cjz,cyj,cya)
jac=[[-b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cjj,b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))-b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cja,-b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cjy,-b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cjz];[1-mj,1-ma,0,0];[-b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cyj,-b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cya,-b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cyy,b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))-b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cyz];[0,0,1-my,1-mz]];
% --------------------------------------------------------------------------
function jacp = jacobianp(t,kmrgd,b1,b2,ma,mj,my,mz,cjj,cja,cyy,cyz,cjy,cjz,cyj,cya)
jacp=[[kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4)),0,0,0,0,0,-b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*kmrgd(1),-b1*kmrgd(2)^2/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2,0,0,-b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*kmrgd(3),-b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*kmrgd(4),0,0];[0,0,-kmrgd(2),-kmrgd(1),0,0,0,0,0,0,0,0,0,0];[0,kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4)),0,0,0,0,0,0,-b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*kmrgd(3),-b2*kmrgd(4)^2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2,0,0,-b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*kmrgd(1),-b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*kmrgd(2)];[0,0,0,0,-kmrgd(3),-kmrgd(4),0,0,0,0,0,0,0,0]];
% --------------------------------------------------------------------------
function hess = hessians(t,kmrgd,b1,b2,ma,mj,my,mz,cjj,cja,cyy,cyz,cjy,cjz,cyj,cya)
hess1=[[2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjj^2,-b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cjj+2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cja*cjj,2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*cjj,2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjj];[0,0,0,0];[2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj^2,2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*cyj,2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy*cyj,-b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cyj+2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyz*cyj];[0,0,0,0]];
hess2=[[-b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cjj+2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cja*cjj,-2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cja+2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cja^2,-b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cjy+2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*cja,-b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cjz+2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cja];[0,0,0,0];[2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*cyj,2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya^2,2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy*cya,-b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cya+2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyz*cya];[0,0,0,0]];
hess3=[[2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*cjj,-b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cjy+2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*cja,2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy^2,2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjy];[0,0,0,0];[2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy*cyj,2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy*cya,2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy^2,-b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cyy+2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyz*cyy];[0,0,0,0]];
hess4=[[2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjj,-b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cjz+2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cja,2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjy,2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz^2];[0,0,0,0];[-b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cyj+2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyz*cyj,-b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cya+2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyz*cya,-b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cyy+2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyz*cyy,-2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cyz+2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyz^2];[0,0,0,0]];
hess(:,:,1) =hess1;
hess(:,:,2) =hess2;
hess(:,:,3) =hess3;
hess(:,:,4) =hess4;
% --------------------------------------------------------------------------
function hessp = hessiansp(t,kmrgd,b1,b2,ma,mj,my,mz,cjj,cja,cyy,cyz,cjy,cjz,cyj,cya)
hessp1=[[-kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cjj,1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))-kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cja,-kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cjy,-kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*cjz];[0,0,0,0];[0,0,0,0];[0,0,0,0]];
hessp2=[[0,0,0,0];[0,0,0,0];[-kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cyj,-kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cya,-kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cyy,1/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))-kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*cyz];[0,0,0,0]];
hessp3=[[0,0,0,0];[0,-1,0,0];[0,0,0,0];[0,0,0,0]];
hessp4=[[0,0,0,0];[-1,0,0,0];[0,0,0,0];[0,0,0,0]];
hessp5=[[0,0,0,0];[0,0,0,0];[0,0,0,0];[0,0,-1,0]];
hessp6=[[0,0,0,0];[0,0,0,0];[0,0,0,0];[0,0,0,-1]];
hessp7=[[2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjj*kmrgd(1)-b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2,-b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*kmrgd(1)+2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cja*kmrgd(1),2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*kmrgd(1),2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*kmrgd(1)];[0,0,0,0];[0,0,0,0];[0,0,0,0]];
hessp8=[[2*b1*kmrgd(2)^2/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjj,-2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2+2*b1*kmrgd(2)^2/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cja,2*b1*kmrgd(2)^2/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy,2*b1*kmrgd(2)^2/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz];[0,0,0,0];[0,0,0,0];[0,0,0,0]];
hessp9=[[0,0,0,0];[0,0,0,0];[2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*kmrgd(3),2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*kmrgd(3),2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy*kmrgd(3)-b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2,-b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*kmrgd(3)+2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyz*kmrgd(3)];[0,0,0,0]];
hessp10=[[0,0,0,0];[0,0,0,0];[2*b2*kmrgd(4)^2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj,2*b2*kmrgd(4)^2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya,2*b2*kmrgd(4)^2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy,-2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2+2*b2*kmrgd(4)^2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyz];[0,0,0,0]];
hessp11=[[2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjj*kmrgd(3),-b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*kmrgd(3)+2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cja*kmrgd(3),2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*kmrgd(3)-b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2,2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*kmrgd(3)];[0,0,0,0];[0,0,0,0];[0,0,0,0]];
hessp12=[[2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjj*kmrgd(4),-b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2*kmrgd(4)+2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cja*kmrgd(4),2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*kmrgd(4),2*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*kmrgd(4)-b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^2];[0,0,0,0];[0,0,0,0];[0,0,0,0]];
hessp13=[[0,0,0,0];[0,0,0,0];[2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*kmrgd(1)-b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2,2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*kmrgd(1),2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy*kmrgd(1),-b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*kmrgd(1)+2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyz*kmrgd(1)];[0,0,0,0]];
hessp14=[[0,0,0,0];[0,0,0,0];[2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*kmrgd(2),2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*kmrgd(2)-b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2,2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy*kmrgd(2),-b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^2*kmrgd(2)+2*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyz*kmrgd(2)];[0,0,0,0]];
hessp(:,:,1) =hessp1;
hessp(:,:,2) =hessp2;
hessp(:,:,3) =hessp3;
hessp(:,:,4) =hessp4;
hessp(:,:,5) =hessp5;
hessp(:,:,6) =hessp6;
hessp(:,:,7) =hessp7;
hessp(:,:,8) =hessp8;
hessp(:,:,9) =hessp9;
hessp(:,:,10) =hessp10;
hessp(:,:,11) =hessp11;
hessp(:,:,12) =hessp12;
hessp(:,:,13) =hessp13;
hessp(:,:,14) =hessp14;
%---------------------------------------------------------------------------
function tens3  = der3(t,kmrgd,b1,b2,ma,mj,my,mz,cjj,cja,cyy,cyz,cjy,cjz,cyj,cya)
tens31=[[-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^3,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjj^2-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cja*cjj^2,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj^2,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj^2];[0,0,0,0];[-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^3,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyj^2,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj^2,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj^2-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj^2];[0,0,0,0]];
tens32=[[2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjj^2-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cja*cjj^2,4*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjj*cja-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cja^2*cjj,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*cjj-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjj-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja];[0,0,0,0];[-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyj^2,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyj,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cya,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cya-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj*cya];[0,0,0,0]];
tens33=[[-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj^2,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*cjj-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy];[0,0,0,0];[-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj^2,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cya,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyj,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cyy-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj*cyy];[0,0,0,0]];
tens34=[[-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj^2,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjj-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj];[0,0,0,0];[2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj^2-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj^2,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cya-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj*cya,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cyy-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj*cyy,4*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cyz-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^2*cyj];[0,0,0,0]];
tens35=[[2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjj^2-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cja*cjj^2,4*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjj*cja-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cja^2*cjj,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*cjj-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjj-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja];[0,0,0,0];[-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyj^2,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyj,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cya,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cya-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj*cya];[0,0,0,0]];
tens36=[[4*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjj*cja-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cja^2*cjj,6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cja^2-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cja^3,4*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*cja-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cja^2,4*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cja-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja^2];[0,0,0,0];[-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyj,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^3,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cya^2,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya^2-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cya^2];[0,0,0,0]];
tens37=[[2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*cjj-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja,4*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*cja-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cja^2,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy^2-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cja,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjy-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy];[0,0,0,0];[-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cya,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cya^2,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cya,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*cyy-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cya*cyy];[0,0,0,0]];
tens38=[[2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjj-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja,4*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cja-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja^2,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjy-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz^2-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cja];[0,0,0,0];[2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cya-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj*cya,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya^2-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cya^2,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*cyy-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cya*cyy,4*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*cyz-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^2*cya];[0,0,0,0]];
tens39=[[-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj^2,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*cjj-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy];[0,0,0,0];[-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj^2,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cya,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyj,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cyy-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj*cyy];[0,0,0,0]];
tens310=[[2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*cjj-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja,4*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy*cja-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cja^2,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy^2-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cja,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjy-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy];[0,0,0,0];[-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cya,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cya^2,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cya,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*cyy-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cya*cyy];[0,0,0,0]];
tens311=[[-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjy^2-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cja,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^3,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2];[0,0,0,0];[-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyj,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cya,-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^3,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy^2-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyy^2];[0,0,0,0]];
tens312=[[-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjy-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy];[0,0,0,0];[2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cyy-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj*cyy,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*cyy-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cya*cyy,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy^2-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyy^2,4*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy*cyz-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^2*cyy];[0,0,0,0]];
tens313=[[-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj^2,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjj-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj];[0,0,0,0];[2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj^2-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj^2,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cya-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj*cya,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cyy-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj*cyy,4*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cyz-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^2*cyj];[0,0,0,0]];
tens314=[[2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjj-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja,4*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cja-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja^2,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjy-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz^2-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cja];[0,0,0,0];[2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cya-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj*cya,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya^2-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cya^2,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*cyy-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cya*cyy,4*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*cyz-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^2*cya];[0,0,0,0]];
tens315=[[-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz*cjy-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy];[0,0,0,0];[2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cyy-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj*cyy,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*cyy-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cya*cyy,2*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy^2-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyy^2,4*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy*cyz-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^2*cyy];[0,0,0,0]];
tens316=[[-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj,2*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^3*cjz^2-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cja,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy,-6*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^3];[0,0,0,0];[4*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyj*cyz-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^2*cyj,4*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cya*cyz-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^2*cya,4*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyy*cyz-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^2*cyy,6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^3*cyz^2-6*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^3];[0,0,0,0]];
tens3(:,:,1,1) =tens31;
tens3(:,:,1,2) =tens32;
tens3(:,:,1,3) =tens33;
tens3(:,:,1,4) =tens34;
tens3(:,:,2,1) =tens35;
tens3(:,:,2,2) =tens36;
tens3(:,:,2,3) =tens37;
tens3(:,:,2,4) =tens38;
tens3(:,:,3,1) =tens39;
tens3(:,:,3,2) =tens310;
tens3(:,:,3,3) =tens311;
tens3(:,:,3,4) =tens312;
tens3(:,:,4,1) =tens313;
tens3(:,:,4,2) =tens314;
tens3(:,:,4,3) =tens315;
tens3(:,:,4,4) =tens316;
%---------------------------------------------------------------------------
function tens4  = der4(t,kmrgd,b1,b2,ma,mj,my,mz,cjj,cja,cyy,cyz,cjy,cjz,cyj,cya)
tens41=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^4,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^3+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja*cjj^3,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^3,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^3];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^4,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^3,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^3+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^3];[0,0,0,0]];
tens42=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^3+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja*cjj^3,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja^2*cjj^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cya+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya];[0,0,0,0]];
tens43=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^3,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cjy];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^3,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cya,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cyy];[0,0,0,0]];
tens44=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^3,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cjy,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^3+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^3,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cya+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cyy,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj^2];[0,0,0,0]];
tens45=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^3+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja*cjj^3,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja^2*cjj^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cya+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya];[0,0,0,0]];
tens46=[[-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja^2*cjj^2,-18*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj*cja^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja^3*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyj,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2];[0,0,0,0]];
tens47=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja*cjy];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cya,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj*cya^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya*cyy];[0,0,0,0]];
tens48=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cya+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya*cyy,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj*cya];[0,0,0,0]];
tens49=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^3,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cjy];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^3,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cya,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cyy];[0,0,0,0]];
tens410=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja*cjy];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cya,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj*cya^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya*cyy];[0,0,0,0]];
tens411=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cjy^2];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cyy^2];[0,0,0,0]];
tens412=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja*cjy,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cjy^2,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cjy];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cyy,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya*cyy,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cyy^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj*cyy];[0,0,0,0]];
tens413=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^3,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cjy,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^3+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^3,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cya+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cyy,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj^2];[0,0,0,0]];
tens414=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cya+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya*cyy,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj*cya];[0,0,0,0]];
tens415=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja*cjy,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cjy^2,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cjy];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cyy,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya*cyy,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cyy^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj*cyy];[0,0,0,0]];
tens416=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cjy,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj];[0,0,0,0];[-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj*cya,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj*cyy,-18*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cyz^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyj];[0,0,0,0]];
tens417=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^3+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja*cjj^3,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja^2*cjj^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cya+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya];[0,0,0,0]];
tens418=[[-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja^2*cjj^2,-18*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj*cja^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja^3*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyj,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2];[0,0,0,0]];
tens419=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja*cjy];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cya,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj*cya^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya*cyy];[0,0,0,0]];
tens420=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^2*cya+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya*cyy,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj*cya];[0,0,0,0]];
tens421=[[-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja^2*cjj^2,-18*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj*cja^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja^3*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyj,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2];[0,0,0,0]];
tens422=[[-18*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj*cja^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja^3*cjj,-24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cja^3+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja^4,-18*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cja^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cja^3,-18*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^3];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyj,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^4,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cya^3,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^3+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^3];[0,0,0,0]];
tens423=[[-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2,-18*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cja^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cja^3,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj*cya^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cya^3,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^2*cyy];[0,0,0,0]];
tens424=[[-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2,-18*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^3,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^3+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^3,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^2*cyy,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya^2];[0,0,0,0]];
tens425=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja*cjj^2*cjy,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj*cya^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj];[0,0,0,0]];
tens426=[[-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2,-18*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cja^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cja^3,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj*cya^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cya^3,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^2*cyy];[0,0,0,0]];
tens427=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^3+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya*cyj,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2];[0,0,0,0]];
tens428=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^2*cyy,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy];[0,0,0,0]];
tens429=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cjz+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja*cjj^2*cjz,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjj];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyj^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyz*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj];[0,0,0,0]];
tens430=[[-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2,-18*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^3,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^3+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^3,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^2*cyy,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya^2];[0,0,0,0]];
tens431=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^2*cyy,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy];[0,0,0,0]];
tens432=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^3+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja];[0,0,0,0];[-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyz*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy,-18*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyz^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cya];[0,0,0,0]];
tens433=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja*cjj^2*cjy,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy*cjj^2];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy*cyj^2];[0,0,0,0]];
tens434=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja*cjj^2*cjy,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj*cya^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj];[0,0,0,0]];
tens435=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya*cyj,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj];[0,0,0,0]];
tens436=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy*cjj^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy*cyj^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj];[0,0,0,0]];
tens437=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja*cjj^2*cjy,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj*cya^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj];[0,0,0,0]];
tens438=[[-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2,-18*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy*cja^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cja^3,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj*cya^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cya^3,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^2*cyy];[0,0,0,0]];
tens439=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^3+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya*cyj,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2];[0,0,0,0]];
tens440=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^2*cyy,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy];[0,0,0,0]];
tens441=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya*cyj,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj];[0,0,0,0]];
tens442=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^3+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya*cyj,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya^2,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cya,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2];[0,0,0,0]];
tens443=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjy^3+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^4,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3];[0,0,0,0];[24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cya,24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^4,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^3+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^3];[0,0,0,0]];
tens444=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^3+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^3,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy^2];[0,0,0,0]];
tens445=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy*cjj^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy*cyj^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj];[0,0,0,0]];
tens446=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^2*cyy,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy];[0,0,0,0]];
tens447=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^3+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^3,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy^2];[0,0,0,0]];
tens448=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy];[0,0,0,0];[-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy^2,-18*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyz^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyy];[0,0,0,0]];
tens449=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cjz+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja*cjj^2*cjz,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy*cjj^2,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj^3+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyz,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyj^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy*cyj^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj^2];[0,0,0,0]];
tens450=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cjz+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja*cjj^2*cjz,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjj];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyj^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyz*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj];[0,0,0,0]];
tens451=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy*cjj^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy*cyj^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj];[0,0,0,0]];
tens452=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj];[0,0,0,0];[-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyz*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj,-18*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^2*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyj];[0,0,0,0]];
tens453=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjj^2*cjz+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja*cjj^2*cjz,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjj];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyj^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyz*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj];[0,0,0,0]];
tens454=[[-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjj*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2,-18*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^3,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyj*cya^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^3+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^3,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^2*cyy,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya^2];[0,0,0,0]];
tens455=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^2*cyy,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy];[0,0,0,0]];
tens456=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^3+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja];[0,0,0,0];[-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyz*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy,-18*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyz^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cya];[0,0,0,0]];
tens457=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy*cjj^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy*cyj^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj];[0,0,0,0]];
tens458=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cja*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyy+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^2*cyy,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy];[0,0,0,0]];
tens459=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz*cjy^2+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2];[0,0,0,0];[-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2,-6*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^3+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^3,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy^2];[0,0,0,0]];
tens460=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy];[0,0,0,0];[-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy^2,-18*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyz^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyy];[0,0,0,0]];
tens461=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj];[0,0,0,0];[-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz*cyj^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyz*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj,-18*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^2*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyj];[0,0,0,0]];
tens462=[[-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjj+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjj,-12*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cja+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^3+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja];[0,0,0,0];[-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyz*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya^2,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy,-18*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyz^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cya];[0,0,0,0]];
tens463=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^2*cjy+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy];[0,0,0,0];[-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyj*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyy*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy,-12*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy^2*cyz+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy^2,-18*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyz^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyy];[0,0,0,0]];
tens464=[[24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj,-6*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^4*cjz^3+24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy,24*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^4];[0,0,0,0];[-18*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^2*cyj+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyj,-18*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cya*cyz^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cya,-18*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyy*cyz^2+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyy,-24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^4*cyz^3+24*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^4];[0,0,0,0]];
tens4(:,:,1,1,1) =tens41;
tens4(:,:,1,1,2) =tens42;
tens4(:,:,1,1,3) =tens43;
tens4(:,:,1,1,4) =tens44;
tens4(:,:,1,2,1) =tens45;
tens4(:,:,1,2,2) =tens46;
tens4(:,:,1,2,3) =tens47;
tens4(:,:,1,2,4) =tens48;
tens4(:,:,1,3,1) =tens49;
tens4(:,:,1,3,2) =tens410;
tens4(:,:,1,3,3) =tens411;
tens4(:,:,1,3,4) =tens412;
tens4(:,:,1,4,1) =tens413;
tens4(:,:,1,4,2) =tens414;
tens4(:,:,1,4,3) =tens415;
tens4(:,:,1,4,4) =tens416;
tens4(:,:,2,1,1) =tens417;
tens4(:,:,2,1,2) =tens418;
tens4(:,:,2,1,3) =tens419;
tens4(:,:,2,1,4) =tens420;
tens4(:,:,2,2,1) =tens421;
tens4(:,:,2,2,2) =tens422;
tens4(:,:,2,2,3) =tens423;
tens4(:,:,2,2,4) =tens424;
tens4(:,:,2,3,1) =tens425;
tens4(:,:,2,3,2) =tens426;
tens4(:,:,2,3,3) =tens427;
tens4(:,:,2,3,4) =tens428;
tens4(:,:,2,4,1) =tens429;
tens4(:,:,2,4,2) =tens430;
tens4(:,:,2,4,3) =tens431;
tens4(:,:,2,4,4) =tens432;
tens4(:,:,3,1,1) =tens433;
tens4(:,:,3,1,2) =tens434;
tens4(:,:,3,1,3) =tens435;
tens4(:,:,3,1,4) =tens436;
tens4(:,:,3,2,1) =tens437;
tens4(:,:,3,2,2) =tens438;
tens4(:,:,3,2,3) =tens439;
tens4(:,:,3,2,4) =tens440;
tens4(:,:,3,3,1) =tens441;
tens4(:,:,3,3,2) =tens442;
tens4(:,:,3,3,3) =tens443;
tens4(:,:,3,3,4) =tens444;
tens4(:,:,3,4,1) =tens445;
tens4(:,:,3,4,2) =tens446;
tens4(:,:,3,4,3) =tens447;
tens4(:,:,3,4,4) =tens448;
tens4(:,:,4,1,1) =tens449;
tens4(:,:,4,1,2) =tens450;
tens4(:,:,4,1,3) =tens451;
tens4(:,:,4,1,4) =tens452;
tens4(:,:,4,2,1) =tens453;
tens4(:,:,4,2,2) =tens454;
tens4(:,:,4,2,3) =tens455;
tens4(:,:,4,2,4) =tens456;
tens4(:,:,4,3,1) =tens457;
tens4(:,:,4,3,2) =tens458;
tens4(:,:,4,3,3) =tens459;
tens4(:,:,4,3,4) =tens460;
tens4(:,:,4,4,1) =tens461;
tens4(:,:,4,4,2) =tens462;
tens4(:,:,4,4,3) =tens463;
tens4(:,:,4,4,4) =tens464;
%---------------------------------------------------------------------------
function tens5  = der5(t,kmrgd,b1,b2,ma,mj,my,mz,cjj,cja,cyy,cyz,cjy,cjz,cyj,cya)
tens51=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^5,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^4,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^4*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^4*cjz];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^5,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^4,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^4*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^4*cyz];[0,0,0,0]];
tens52=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^4,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cja];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^4,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cya];[0,0,0,0]];
tens53=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^4*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^4*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cyy];[0,0,0,0]];
tens54=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^4*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^4*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz^2];[0,0,0,0]];
tens55=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^4,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cja];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^4,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cya];[0,0,0,0]];
tens56=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^3,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz];[0,0,0,0]];
tens57=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy];[0,0,0,0]];
tens58=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2];[0,0,0,0]];
tens59=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^4*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^4*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cyy];[0,0,0,0]];
tens510=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy];[0,0,0,0]];
tens511=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^2*cjj^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyy^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^2*cyj^2];[0,0,0,0]];
tens512=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^2*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^2*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2];[0,0,0,0]];
tens513=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^4*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^4*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz^2];[0,0,0,0]];
tens514=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2];[0,0,0,0]];
tens515=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^2*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^2*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2];[0,0,0,0]];
tens516=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjj^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyj^2];[0,0,0,0]];
tens517=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^4,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cja];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^4,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cya];[0,0,0,0]];
tens518=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^3,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz];[0,0,0,0]];
tens519=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy];[0,0,0,0]];
tens520=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2];[0,0,0,0]];
tens521=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^3,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz];[0,0,0,0]];
tens522=[[72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjj^2,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^4*cjj,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^4*cyj,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3];[0,0,0,0]];
tens523=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy];[0,0,0,0]];
tens524=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2];[0,0,0,0]];
tens525=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy];[0,0,0,0]];
tens526=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy];[0,0,0,0]];
tens527=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjy^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^3*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyy^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^3*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2];[0,0,0,0]];
tens528=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy];[0,0,0,0]];
tens529=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2];[0,0,0,0]];
tens530=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2];[0,0,0,0]];
tens531=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy];[0,0,0,0]];
tens532=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^3*cja];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^3*cya];[0,0,0,0]];
tens533=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^4*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^4*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cyy];[0,0,0,0]];
tens534=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy];[0,0,0,0]];
tens535=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyy^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cyy^2];[0,0,0,0]];
tens536=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz^2*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz^2*cyy];[0,0,0,0]];
tens537=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy];[0,0,0,0]];
tens538=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy];[0,0,0,0]];
tens539=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjy^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^3*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyy^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^3*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2];[0,0,0,0]];
tens540=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy];[0,0,0,0]];
tens541=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyy^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cyy^2];[0,0,0,0]];
tens542=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjy^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^3*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyy^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^3*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2];[0,0,0,0]];
tens543=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^3*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^4,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cjy^3];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^3*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^4,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cyy^3];[0,0,0,0]];
tens544=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cyy^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cyy^2];[0,0,0,0]];
tens545=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz^2*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz^2*cyy];[0,0,0,0]];
tens546=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy];[0,0,0,0]];
tens547=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cyy^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cyy^2];[0,0,0,0]];
tens548=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^3*cjy];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^3*cyy];[0,0,0,0]];
tens549=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^4*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjz,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^4*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz^2];[0,0,0,0]];
tens550=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2];[0,0,0,0]];
tens551=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz^2*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz^2*cyy];[0,0,0,0]];
tens552=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz^2*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz^3];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz^2*cyy,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz^3];[0,0,0,0]];
tens553=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2];[0,0,0,0]];
tens554=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2];[0,0,0,0]];
tens555=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy];[0,0,0,0]];
tens556=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^3*cja];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^3*cya];[0,0,0,0]];
tens557=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz^2*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz^2*cyy];[0,0,0,0]];
tens558=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy];[0,0,0,0]];
tens559=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cyy^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cyy^2];[0,0,0,0]];
tens560=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^3*cjy];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^3*cyy];[0,0,0,0]];
tens561=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz^2*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz^3];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz^2*cyy,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz^3];[0,0,0,0]];
tens562=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^3*cja];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^3*cya];[0,0,0,0]];
tens563=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^3*cjy];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^3*cyy];[0,0,0,0]];
tens564=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^3*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^3*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^4];[0,0,0,0];[72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz^3,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^3*cya,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyy*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^3*cyy,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cyz^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^4];[0,0,0,0]];
tens565=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^4,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjz];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^4,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyz];[0,0,0,0]];
tens566=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^3,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz];[0,0,0,0]];
tens567=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy];[0,0,0,0]];
tens568=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2];[0,0,0,0]];
tens569=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz];[0,0,0,0]];
tens570=[[72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjj^2,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^4*cjj,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^4*cyj,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3];[0,0,0,0]];
tens571=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy];[0,0,0,0]];
tens572=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2];[0,0,0,0]];
tens573=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cja*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy^2*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cya*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy^2*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy];[0,0,0,0]];
tens574=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy];[0,0,0,0]];
tens575=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy^2*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^3*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy^2*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^3*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2];[0,0,0,0]];
tens576=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy];[0,0,0,0]];
tens577=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2];[0,0,0,0]];
tens578=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2];[0,0,0,0]];
tens579=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy];[0,0,0,0]];
tens580=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^3*cja];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^3*cya];[0,0,0,0]];
tens581=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz];[0,0,0,0]];
tens582=[[72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjj^2,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^4*cjj,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^4*cyj,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3];[0,0,0,0]];
tens583=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy];[0,0,0,0]];
tens584=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2];[0,0,0,0]];
tens585=[[72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjj^2,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^4*cjj,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^4*cyj,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3];[0,0,0,0]];
tens586=[[96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^4*cjj,120*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cja^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^5,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^4,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^4];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^4*cyj,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^5,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^4,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^4];[0,0,0,0]];
tens587=[[72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^4,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^3,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^4,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy];[0,0,0,0]];
tens588=[[72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^4,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^3];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^4,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^3];[0,0,0,0]];
tens589=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy];[0,0,0,0]];
tens590=[[72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^4,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^3,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^4,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy];[0,0,0,0]];
tens591=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2];[0,0,0,0]];
tens592=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy];[0,0,0,0]];
tens593=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2];[0,0,0,0]];
tens594=[[72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^4,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^3];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^4,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^3];[0,0,0,0]];
tens595=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy];[0,0,0,0]];
tens596=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya^2];[0,0,0,0]];
tens597=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cja*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy^2*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cya*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy^2*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy];[0,0,0,0]];
tens598=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy];[0,0,0,0]];
tens599=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy^2*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^3*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy^2*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^3*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2];[0,0,0,0]];
tens5100=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy];[0,0,0,0]];
tens5101=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy];[0,0,0,0]];
tens5102=[[72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy*cja^3,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^4,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^3,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^4,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy];[0,0,0,0]];
tens5103=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2];[0,0,0,0]];
tens5104=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy];[0,0,0,0]];
tens5105=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjy^2*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^3*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyy^2*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^3*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2];[0,0,0,0]];
tens5106=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^2*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^2*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2];[0,0,0,0]];
tens5107=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjy^3*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^4*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyy^3*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^4*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3];[0,0,0,0]];
tens5108=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2];[0,0,0,0]];
tens5109=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy];[0,0,0,0]];
tens5110=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy];[0,0,0,0]];
tens5111=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2];[0,0,0,0]];
tens5112=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy];[0,0,0,0]];
tens5113=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^3*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^3*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2];[0,0,0,0]];
tens5114=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2];[0,0,0,0]];
tens5115=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy];[0,0,0,0]];
tens5116=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjj^2*cjz^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^3*cja];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyj^2*cyz^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyy*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya*cyy,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^3*cya];[0,0,0,0]];
tens5117=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjj^2*cjz,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2];[0,0,0,0]];
tens5118=[[72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^3,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^4,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^3];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^4,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^3];[0,0,0,0]];
tens5119=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyz*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy];[0,0,0,0]];
tens5120=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyz*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya^2];[0,0,0,0]];
tens5121=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cja*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cya*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj];[0,0,0,0]];
tens5122=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyz*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy];[0,0,0,0]];
tens5123=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2];[0,0,0,0]];
tens5124=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyz*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy];[0,0,0,0]];
tens5125=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz^2*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjj];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cya*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz^2*cya,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyj];[0,0,0,0]];
tens5126=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz^2*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz^2*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyz*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya^2];[0,0,0,0]];
tens5127=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyz*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy];[0,0,0,0]];
tens5128=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cja];[0,0,0,0];[72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cya];[0,0,0,0]];
tens5129=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^4*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja*cjj^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy*cjj^3];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^4*cyy,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy*cyj^3];[0,0,0,0]];
tens5130=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja*cjj^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^2*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cja*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^2*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cya*cyy];[0,0,0,0]];
tens5131=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^2*cjj^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^2*cyj^2];[0,0,0,0]];
tens5132=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy*cjj^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cja*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^2*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy*cyj^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cya*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^2*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2];[0,0,0,0]];
tens5133=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja*cjj^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^2*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cja*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^2*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cya*cyy];[0,0,0,0]];
tens5134=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^2*cjj^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^3*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^2*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^3*cyj,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy];[0,0,0,0]];
tens5135=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj];[0,0,0,0]];
tens5136=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cja*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cya*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj];[0,0,0,0]];
tens5137=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^2*cjj^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^2*cyj^2];[0,0,0,0]];
tens5138=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj];[0,0,0,0]];
tens5139=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^4*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^3*cjj];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^4*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^3*cyj];[0,0,0,0]];
tens5140=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^2*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^3*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^2*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^3*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj];[0,0,0,0]];
tens5141=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy*cjj^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cja*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^2*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy*cyj^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cya*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^2*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2];[0,0,0,0]];
tens5142=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cja*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cya*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj];[0,0,0,0]];
tens5143=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^2*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^3*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^2*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^3*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj];[0,0,0,0]];
tens5144=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyj*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj];[0,0,0,0]];
tens5145=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja*cjj^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^2*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cja*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^2*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cya*cyy];[0,0,0,0]];
tens5146=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^2*cjj^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^3*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^2*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^3*cyj,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy];[0,0,0,0]];
tens5147=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj];[0,0,0,0]];
tens5148=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cja*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cya*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj];[0,0,0,0]];
tens5149=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^2*cjj^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^3*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^2*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^3*cyj,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy];[0,0,0,0]];
tens5150=[[72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjj*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^3*cjj,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy*cja^4,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^3,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^3*cyj,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy*cya^4,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy];[0,0,0,0]];
tens5151=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2];[0,0,0,0]];
tens5152=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyz*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy];[0,0,0,0]];
tens5153=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj];[0,0,0,0]];
tens5154=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2];[0,0,0,0]];
tens5155=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^4*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^4*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3];[0,0,0,0]];
tens5156=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2];[0,0,0,0]];
tens5157=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj^2*cjz*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^2*cjz*cja*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^2*cyz*cya*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj];[0,0,0,0]];
tens5158=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjj*cjz*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj*cjz*cja^2*cjy,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^3*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj*cya^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj*cyz*cya^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^3*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyz*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy];[0,0,0,0]];
tens5159=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2];[0,0,0,0]];
tens5160=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^2*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyz*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^2*cyy,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyz^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy];[0,0,0,0]];
tens5161=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^2*cjj^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^2*cyj^2];[0,0,0,0]];
tens5162=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj];[0,0,0,0]];
tens5163=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^4*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^3*cjj];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^4*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^3*cyj];[0,0,0,0]];
tens5164=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^2*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^3*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^2*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^3*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj];[0,0,0,0]];
tens5165=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^2*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^2*cjj];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^2*cyj];[0,0,0,0]];
tens5166=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja^2*cjy^2];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^3,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cya^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya^2*cyy^2];[0,0,0,0]];
tens5167=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^4*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^4*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3];[0,0,0,0]];
tens5168=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2];[0,0,0,0]];
tens5169=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^4*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^3*cjj];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^4*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^3*cyj];[0,0,0,0]];
tens5170=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjj*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^4*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyj*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cya^2,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^4*cya,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3];[0,0,0,0]];
tens5171=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^4*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^4*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^5,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^4];[0,0,0,0];[-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^4*cyj,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^4*cya,-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^5,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^4];[0,0,0,0]];
tens5172=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^3*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^4,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^3];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^3*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^4,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^3];[0,0,0,0]];
tens5173=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja*cjz,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^3*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^3*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj];[0,0,0,0]];
tens5174=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2];[0,0,0,0]];
tens5175=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^3*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^4,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^3];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^3*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^4,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^3];[0,0,0,0]];
tens5176=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^3,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy^2];[0,0,0,0]];
tens5177=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy*cjz*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cjz,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2];[0,0,0,0]];
tens5178=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy*cjz*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya];[0,0,0,0]];
tens5179=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja*cjz,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^3*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^3*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj];[0,0,0,0]];
tens5180=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj];[0,0,0,0]];
tens5181=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy*cjz*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya];[0,0,0,0]];
tens5182=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjy*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^2*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyy*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^2*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2];[0,0,0,0]];
tens5183=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2];[0,0,0,0]];
tens5184=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cja];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz^2*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cya];[0,0,0,0]];
tens5185=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja*cjz,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^3*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^3*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj];[0,0,0,0]];
tens5186=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2];[0,0,0,0]];
tens5187=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^3*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjy^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cja*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^4,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^3];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^3*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cya*cyy^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^4,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^3];[0,0,0,0]];
tens5188=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^3,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy^2];[0,0,0,0]];
tens5189=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj];[0,0,0,0]];
tens5190=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cja];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz^2*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cya];[0,0,0,0]];
tens5191=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^3,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy^2];[0,0,0,0]];
tens5192=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cjy];[0,0,0,0];[72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz^2*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cya,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy^2,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cyy];[0,0,0,0]];
tens5193=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^4*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjz*cjj^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy*cjz,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj^3];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^4*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyz*cyj^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj^3];[0,0,0,0]];
tens5194=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjz*cjj^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjz*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy*cjz*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj^2*cja];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyz*cyj^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy*cyz*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj^2*cya];[0,0,0,0]];
tens5195=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy*cjz*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cjz,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2];[0,0,0,0]];
tens5196=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj^2*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjj^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj^2*cya,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyj^2];[0,0,0,0]];
tens5197=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjz*cjj^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjz*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy*cjz*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj^2*cja];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyz*cyj^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy*cyz*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj^2*cya];[0,0,0,0]];
tens5198=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjz*cjj^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjz*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj*cya^2];[0,0,0,0]];
tens5199=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy*cjz*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya];[0,0,0,0]];
tens5200=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj^2*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjj*cja];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj^2*cya,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyj*cya];[0,0,0,0]];
tens5201=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjy*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy*cjz*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cjz,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyy*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2];[0,0,0,0]];
tens5202=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy*cjz*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya];[0,0,0,0]];
tens5203=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja*cjz,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz*cjy^3*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz*cyy^3*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj];[0,0,0,0]];
tens5204=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj];[0,0,0,0]];
tens5205=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj^3,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj^2*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjj^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj^2*cya,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyj^2];[0,0,0,0]];
tens5206=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj^2*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjj*cja];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj^2*cya,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyj*cya];[0,0,0,0]];
tens5207=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyz*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj];[0,0,0,0]];
tens5208=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjj*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cjj];[0,0,0,0];[72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyj^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyj*cya,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cyj];[0,0,0,0]];
tens5209=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjz*cjj^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjz*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy*cjz*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj^2*cja];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyz*cyj^3,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy*cyz*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj^2*cya];[0,0,0,0]];
tens5210=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjz*cjj^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjz*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj*cya^2];[0,0,0,0]];
tens5211=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy*cjz*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjj*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjj*cja*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyj*cya*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya];[0,0,0,0]];
tens5212=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj^2*cja,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj*cja,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjj*cja];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj^2*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj^2*cya,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj*cya,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyj*cya];[0,0,0,0]];
tens5213=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjz*cjj^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjz*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj*cya^2];[0,0,0,0]];
tens5214=[[72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjz*cjj,96*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cja^3-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^4*cjz,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjy*cjz,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^3];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^4*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyy*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^3];[0,0,0,0]];
tens5215=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjy*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cja*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cja^2*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyy*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cya^2*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2];[0,0,0,0]];
tens5216=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya^2];[0,0,0,0]];
tens5217=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjz*cjj^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cja*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjz*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy^2*cjz*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyz*cyj^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy^2*cyz*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj];[0,0,0,0]];
tens5218=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cja*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjy*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy^2*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyy*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy^2*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2];[0,0,0,0]];
tens5219=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjz*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy^2*cjz*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy^3*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy^2*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy^3*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2];[0,0,0,0]];
tens5220=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy];[0,0,0,0]];
tens5221=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjz^2*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjj];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyz^2*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyj];[0,0,0,0]];
tens5222=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya^2];[0,0,0,0]];
tens5223=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy];[0,0,0,0]];
tens5224=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cja];[0,0,0,0];[72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cya];[0,0,0,0]];
tens5225=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjz*cjj^2*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjz*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyz*cyj^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyz*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2];[0,0,0,0]];
tens5226=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjz*cjj^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cja*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjz*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy^2*cjz*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyz*cyj^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy^2*cyz*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj];[0,0,0,0]];
tens5227=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjz*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjz*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy^2*cjz*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjz*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy^2*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyz*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj];[0,0,0,0]];
tens5228=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj];[0,0,0,0]];
tens5229=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz*cjj^2*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjz*cjj^2*cjy,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cja*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjz*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy^2*cjz*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyz*cyj^2*cyy,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy^2*cyz*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj];[0,0,0,0]];
tens5230=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cja*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy*cjz*cjj,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy*cjz*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^3*cjy*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy^2*cjz,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^3*cyy*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy^2*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2];[0,0,0,0]];
tens5231=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjz*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy^2*cjz*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy^3*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy^2*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy^3*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2];[0,0,0,0]];
tens5232=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy];[0,0,0,0]];
tens5233=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^2*cjz*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjz*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy^2*cjz*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjz*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^2*cyz*cyj^2,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy^2*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyz*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj];[0,0,0,0]];
tens5234=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjz*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy^2*cjz*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^2*cjz*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja^2*cjy^2*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy^3*cjz,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy^2*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya^2*cyy^2*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy^3*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2];[0,0,0,0]];
tens5235=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^3*cjz*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjy^3*cjz-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjy^3*cjz,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjy^4*cjz,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^3];[0,0,0,0];[24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^3*cyz*cyj,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyy^3*cyz,24*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyy^4*cyz,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^3];[0,0,0,0]];
tens5236=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^3,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy^2];[0,0,0,0]];
tens5237=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj];[0,0,0,0]];
tens5238=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy];[0,0,0,0]];
tens5239=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^3,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy^2];[0,0,0,0]];
tens5240=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cjy];[0,0,0,0];[72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy^2,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cyy];[0,0,0,0]];
tens5241=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjj^3*cjz^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjz^2*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjj^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyj^3*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyj^3*cyz^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyz^2*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyj^2];[0,0,0,0]];
tens5242=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjz^2*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjj];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyz^2*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyj];[0,0,0,0]];
tens5243=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj];[0,0,0,0]];
tens5244=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cjj];[0,0,0,0];[72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyj^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cyj];[0,0,0,0]];
tens5245=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cja*cjz^2*cjj^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjj];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cya*cyj^2*cyz-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cya*cyz^2*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyj];[0,0,0,0]];
tens5246=[[48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjj*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjj*cja^2,72*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cja^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja^3,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyj*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyj*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya^3,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya^2];[0,0,0,0]];
tens5247=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy];[0,0,0,0]];
tens5248=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cja];[0,0,0,0];[72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cya];[0,0,0,0]];
tens5249=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cyj^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj];[0,0,0,0]];
tens5250=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyy*cyz*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy*cya^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy];[0,0,0,0]];
tens5251=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^2*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^2*cjy^2-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cja*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^2*cjy^3,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy^2];[0,0,0,0];[48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^2*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^2*cyj,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cya*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cya*cyy^2,48*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz*cyy^3-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^2*cyy^3,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy^2];[0,0,0,0]];
tens5252=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cjy];[0,0,0,0];[72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy^2,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cyy];[0,0,0,0]];
tens5253=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjj^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cjj];[0,0,0,0];[72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyj^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyj^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cyj];[0,0,0,0]];
tens5254=[[24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjj-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjj,48*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cja-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja^2,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cja];[0,0,0,0];[72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya^2,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cya];[0,0,0,0]];
tens5255=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^3*cjy-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cja*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^3*cjy^2,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cjy];[0,0,0,0];[72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy*cyj,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cya*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cya*cyy,72*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^2*cyy^2-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^3*cyy^2,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cyy];[0,0,0,0]];
tens5256=[[-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cjj,24*b1/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^5*cjz^4-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cja,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^4*cjy,-120*b1*kmrgd(2)/(1+cjj*kmrgd(1)+cja*kmrgd(2)+cjy*kmrgd(3)+cjz*kmrgd(4))^6*cjz^5];[0,0,0,0];[96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyj-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cyj,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cya-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cya,96*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^3*cyy-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^4*cyy,120*b2/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^5*cyz^4-120*b2*kmrgd(4)/(1+cyj*kmrgd(1)+cya*kmrgd(2)+cyy*kmrgd(3)+cyz*kmrgd(4))^6*cyz^5];[0,0,0,0]];
tens5(:,:,1,1,1,1) =tens51;
tens5(:,:,1,1,1,2) =tens52;
tens5(:,:,1,1,1,3) =tens53;
tens5(:,:,1,1,1,4) =tens54;
tens5(:,:,1,1,2,1) =tens55;
tens5(:,:,1,1,2,2) =tens56;
tens5(:,:,1,1,2,3) =tens57;
tens5(:,:,1,1,2,4) =tens58;
tens5(:,:,1,1,3,1) =tens59;
tens5(:,:,1,1,3,2) =tens510;
tens5(:,:,1,1,3,3) =tens511;
tens5(:,:,1,1,3,4) =tens512;
tens5(:,:,1,1,4,1) =tens513;
tens5(:,:,1,1,4,2) =tens514;
tens5(:,:,1,1,4,3) =tens515;
tens5(:,:,1,1,4,4) =tens516;
tens5(:,:,1,2,1,1) =tens517;
tens5(:,:,1,2,1,2) =tens518;
tens5(:,:,1,2,1,3) =tens519;
tens5(:,:,1,2,1,4) =tens520;
tens5(:,:,1,2,2,1) =tens521;
tens5(:,:,1,2,2,2) =tens522;
tens5(:,:,1,2,2,3) =tens523;
tens5(:,:,1,2,2,4) =tens524;
tens5(:,:,1,2,3,1) =tens525;
tens5(:,:,1,2,3,2) =tens526;
tens5(:,:,1,2,3,3) =tens527;
tens5(:,:,1,2,3,4) =tens528;
tens5(:,:,1,2,4,1) =tens529;
tens5(:,:,1,2,4,2) =tens530;
tens5(:,:,1,2,4,3) =tens531;
tens5(:,:,1,2,4,4) =tens532;
tens5(:,:,1,3,1,1) =tens533;
tens5(:,:,1,3,1,2) =tens534;
tens5(:,:,1,3,1,3) =tens535;
tens5(:,:,1,3,1,4) =tens536;
tens5(:,:,1,3,2,1) =tens537;
tens5(:,:,1,3,2,2) =tens538;
tens5(:,:,1,3,2,3) =tens539;
tens5(:,:,1,3,2,4) =tens540;
tens5(:,:,1,3,3,1) =tens541;
tens5(:,:,1,3,3,2) =tens542;
tens5(:,:,1,3,3,3) =tens543;
tens5(:,:,1,3,3,4) =tens544;
tens5(:,:,1,3,4,1) =tens545;
tens5(:,:,1,3,4,2) =tens546;
tens5(:,:,1,3,4,3) =tens547;
tens5(:,:,1,3,4,4) =tens548;
tens5(:,:,1,4,1,1) =tens549;
tens5(:,:,1,4,1,2) =tens550;
tens5(:,:,1,4,1,3) =tens551;
tens5(:,:,1,4,1,4) =tens552;
tens5(:,:,1,4,2,1) =tens553;
tens5(:,:,1,4,2,2) =tens554;
tens5(:,:,1,4,2,3) =tens555;
tens5(:,:,1,4,2,4) =tens556;
tens5(:,:,1,4,3,1) =tens557;
tens5(:,:,1,4,3,2) =tens558;
tens5(:,:,1,4,3,3) =tens559;
tens5(:,:,1,4,3,4) =tens560;
tens5(:,:,1,4,4,1) =tens561;
tens5(:,:,1,4,4,2) =tens562;
tens5(:,:,1,4,4,3) =tens563;
tens5(:,:,1,4,4,4) =tens564;
tens5(:,:,2,1,1,1) =tens565;
tens5(:,:,2,1,1,2) =tens566;
tens5(:,:,2,1,1,3) =tens567;
tens5(:,:,2,1,1,4) =tens568;
tens5(:,:,2,1,2,1) =tens569;
tens5(:,:,2,1,2,2) =tens570;
tens5(:,:,2,1,2,3) =tens571;
tens5(:,:,2,1,2,4) =tens572;
tens5(:,:,2,1,3,1) =tens573;
tens5(:,:,2,1,3,2) =tens574;
tens5(:,:,2,1,3,3) =tens575;
tens5(:,:,2,1,3,4) =tens576;
tens5(:,:,2,1,4,1) =tens577;
tens5(:,:,2,1,4,2) =tens578;
tens5(:,:,2,1,4,3) =tens579;
tens5(:,:,2,1,4,4) =tens580;
tens5(:,:,2,2,1,1) =tens581;
tens5(:,:,2,2,1,2) =tens582;
tens5(:,:,2,2,1,3) =tens583;
tens5(:,:,2,2,1,4) =tens584;
tens5(:,:,2,2,2,1) =tens585;
tens5(:,:,2,2,2,2) =tens586;
tens5(:,:,2,2,2,3) =tens587;
tens5(:,:,2,2,2,4) =tens588;
tens5(:,:,2,2,3,1) =tens589;
tens5(:,:,2,2,3,2) =tens590;
tens5(:,:,2,2,3,3) =tens591;
tens5(:,:,2,2,3,4) =tens592;
tens5(:,:,2,2,4,1) =tens593;
tens5(:,:,2,2,4,2) =tens594;
tens5(:,:,2,2,4,3) =tens595;
tens5(:,:,2,2,4,4) =tens596;
tens5(:,:,2,3,1,1) =tens597;
tens5(:,:,2,3,1,2) =tens598;
tens5(:,:,2,3,1,3) =tens599;
tens5(:,:,2,3,1,4) =tens5100;
tens5(:,:,2,3,2,1) =tens5101;
tens5(:,:,2,3,2,2) =tens5102;
tens5(:,:,2,3,2,3) =tens5103;
tens5(:,:,2,3,2,4) =tens5104;
tens5(:,:,2,3,3,1) =tens5105;
tens5(:,:,2,3,3,2) =tens5106;
tens5(:,:,2,3,3,3) =tens5107;
tens5(:,:,2,3,3,4) =tens5108;
tens5(:,:,2,3,4,1) =tens5109;
tens5(:,:,2,3,4,2) =tens5110;
tens5(:,:,2,3,4,3) =tens5111;
tens5(:,:,2,3,4,4) =tens5112;
tens5(:,:,2,4,1,1) =tens5113;
tens5(:,:,2,4,1,2) =tens5114;
tens5(:,:,2,4,1,3) =tens5115;
tens5(:,:,2,4,1,4) =tens5116;
tens5(:,:,2,4,2,1) =tens5117;
tens5(:,:,2,4,2,2) =tens5118;
tens5(:,:,2,4,2,3) =tens5119;
tens5(:,:,2,4,2,4) =tens5120;
tens5(:,:,2,4,3,1) =tens5121;
tens5(:,:,2,4,3,2) =tens5122;
tens5(:,:,2,4,3,3) =tens5123;
tens5(:,:,2,4,3,4) =tens5124;
tens5(:,:,2,4,4,1) =tens5125;
tens5(:,:,2,4,4,2) =tens5126;
tens5(:,:,2,4,4,3) =tens5127;
tens5(:,:,2,4,4,4) =tens5128;
tens5(:,:,3,1,1,1) =tens5129;
tens5(:,:,3,1,1,2) =tens5130;
tens5(:,:,3,1,1,3) =tens5131;
tens5(:,:,3,1,1,4) =tens5132;
tens5(:,:,3,1,2,1) =tens5133;
tens5(:,:,3,1,2,2) =tens5134;
tens5(:,:,3,1,2,3) =tens5135;
tens5(:,:,3,1,2,4) =tens5136;
tens5(:,:,3,1,3,1) =tens5137;
tens5(:,:,3,1,3,2) =tens5138;
tens5(:,:,3,1,3,3) =tens5139;
tens5(:,:,3,1,3,4) =tens5140;
tens5(:,:,3,1,4,1) =tens5141;
tens5(:,:,3,1,4,2) =tens5142;
tens5(:,:,3,1,4,3) =tens5143;
tens5(:,:,3,1,4,4) =tens5144;
tens5(:,:,3,2,1,1) =tens5145;
tens5(:,:,3,2,1,2) =tens5146;
tens5(:,:,3,2,1,3) =tens5147;
tens5(:,:,3,2,1,4) =tens5148;
tens5(:,:,3,2,2,1) =tens5149;
tens5(:,:,3,2,2,2) =tens5150;
tens5(:,:,3,2,2,3) =tens5151;
tens5(:,:,3,2,2,4) =tens5152;
tens5(:,:,3,2,3,1) =tens5153;
tens5(:,:,3,2,3,2) =tens5154;
tens5(:,:,3,2,3,3) =tens5155;
tens5(:,:,3,2,3,4) =tens5156;
tens5(:,:,3,2,4,1) =tens5157;
tens5(:,:,3,2,4,2) =tens5158;
tens5(:,:,3,2,4,3) =tens5159;
tens5(:,:,3,2,4,4) =tens5160;
tens5(:,:,3,3,1,1) =tens5161;
tens5(:,:,3,3,1,2) =tens5162;
tens5(:,:,3,3,1,3) =tens5163;
tens5(:,:,3,3,1,4) =tens5164;
tens5(:,:,3,3,2,1) =tens5165;
tens5(:,:,3,3,2,2) =tens5166;
tens5(:,:,3,3,2,3) =tens5167;
tens5(:,:,3,3,2,4) =tens5168;
tens5(:,:,3,3,3,1) =tens5169;
tens5(:,:,3,3,3,2) =tens5170;
tens5(:,:,3,3,3,3) =tens5171;
tens5(:,:,3,3,3,4) =tens5172;
tens5(:,:,3,3,4,1) =tens5173;
tens5(:,:,3,3,4,2) =tens5174;
tens5(:,:,3,3,4,3) =tens5175;
tens5(:,:,3,3,4,4) =tens5176;
tens5(:,:,3,4,1,1) =tens5177;
tens5(:,:,3,4,1,2) =tens5178;
tens5(:,:,3,4,1,3) =tens5179;
tens5(:,:,3,4,1,4) =tens5180;
tens5(:,:,3,4,2,1) =tens5181;
tens5(:,:,3,4,2,2) =tens5182;
tens5(:,:,3,4,2,3) =tens5183;
tens5(:,:,3,4,2,4) =tens5184;
tens5(:,:,3,4,3,1) =tens5185;
tens5(:,:,3,4,3,2) =tens5186;
tens5(:,:,3,4,3,3) =tens5187;
tens5(:,:,3,4,3,4) =tens5188;
tens5(:,:,3,4,4,1) =tens5189;
tens5(:,:,3,4,4,2) =tens5190;
tens5(:,:,3,4,4,3) =tens5191;
tens5(:,:,3,4,4,4) =tens5192;
tens5(:,:,4,1,1,1) =tens5193;
tens5(:,:,4,1,1,2) =tens5194;
tens5(:,:,4,1,1,3) =tens5195;
tens5(:,:,4,1,1,4) =tens5196;
tens5(:,:,4,1,2,1) =tens5197;
tens5(:,:,4,1,2,2) =tens5198;
tens5(:,:,4,1,2,3) =tens5199;
tens5(:,:,4,1,2,4) =tens5200;
tens5(:,:,4,1,3,1) =tens5201;
tens5(:,:,4,1,3,2) =tens5202;
tens5(:,:,4,1,3,3) =tens5203;
tens5(:,:,4,1,3,4) =tens5204;
tens5(:,:,4,1,4,1) =tens5205;
tens5(:,:,4,1,4,2) =tens5206;
tens5(:,:,4,1,4,3) =tens5207;
tens5(:,:,4,1,4,4) =tens5208;
tens5(:,:,4,2,1,1) =tens5209;
tens5(:,:,4,2,1,2) =tens5210;
tens5(:,:,4,2,1,3) =tens5211;
tens5(:,:,4,2,1,4) =tens5212;
tens5(:,:,4,2,2,1) =tens5213;
tens5(:,:,4,2,2,2) =tens5214;
tens5(:,:,4,2,2,3) =tens5215;
tens5(:,:,4,2,2,4) =tens5216;
tens5(:,:,4,2,3,1) =tens5217;
tens5(:,:,4,2,3,2) =tens5218;
tens5(:,:,4,2,3,3) =tens5219;
tens5(:,:,4,2,3,4) =tens5220;
tens5(:,:,4,2,4,1) =tens5221;
tens5(:,:,4,2,4,2) =tens5222;
tens5(:,:,4,2,4,3) =tens5223;
tens5(:,:,4,2,4,4) =tens5224;
tens5(:,:,4,3,1,1) =tens5225;
tens5(:,:,4,3,1,2) =tens5226;
tens5(:,:,4,3,1,3) =tens5227;
tens5(:,:,4,3,1,4) =tens5228;
tens5(:,:,4,3,2,1) =tens5229;
tens5(:,:,4,3,2,2) =tens5230;
tens5(:,:,4,3,2,3) =tens5231;
tens5(:,:,4,3,2,4) =tens5232;
tens5(:,:,4,3,3,1) =tens5233;
tens5(:,:,4,3,3,2) =tens5234;
tens5(:,:,4,3,3,3) =tens5235;
tens5(:,:,4,3,3,4) =tens5236;
tens5(:,:,4,3,4,1) =tens5237;
tens5(:,:,4,3,4,2) =tens5238;
tens5(:,:,4,3,4,3) =tens5239;
tens5(:,:,4,3,4,4) =tens5240;
tens5(:,:,4,4,1,1) =tens5241;
tens5(:,:,4,4,1,2) =tens5242;
tens5(:,:,4,4,1,3) =tens5243;
tens5(:,:,4,4,1,4) =tens5244;
tens5(:,:,4,4,2,1) =tens5245;
tens5(:,:,4,4,2,2) =tens5246;
tens5(:,:,4,4,2,3) =tens5247;
tens5(:,:,4,4,2,4) =tens5248;
tens5(:,:,4,4,3,1) =tens5249;
tens5(:,:,4,4,3,2) =tens5250;
tens5(:,:,4,4,3,3) =tens5251;
tens5(:,:,4,4,3,4) =tens5252;
tens5(:,:,4,4,4,1) =tens5253;
tens5(:,:,4,4,4,2) =tens5254;
tens5(:,:,4,4,4,3) =tens5255;
tens5(:,:,4,4,4,4) =tens5256;
%--------------------------------------------------------------------------
function userfunc1=userf(t,kmrgd,b1,b2,ma,mj,my,mz,cjj,cja,cyy,cyz,cjy,cjz,cyj,cya)
userfun1=kmrgd(1);
